AddCSLuaFile()

ENT.Type = "anim"
ENT.Base = "long_use_base"
 
ENT.PrintName = "TTT Weapon Crate"
ENT.Author = "SweptThrone"
ENT.Contact = "sweptthr.one/contact"
ENT.Purpose = ""
ENT.Instructions = ""
ENT.Spawnable = true
ENT.AdminSpawnable = false
ENT.Category = "SweptThrone Stuff"

ENT.TimeToUse = 4

if CLIENT then
    function ENT:Draw()
        self:DrawModel()

        local Pos = self:GetPos()
        local Ang = self:GetAngles()
        
        Ang:RotateAroundAxis( Ang:Forward(), 90 )
        Ang:RotateAroundAxis( Ang:Right(), 270 )
        
        local txt = self:GetNWInt( "WeaponsLeft", 0 ) .. " Weapons Left"
        
        surface.SetFont( "DermaLarge" )
        local TextWidth = surface.GetTextSize( txt )
        
        cam.Start3D2D( Pos - Ang:Right() * -25 + Ang:Up() * 17, Ang, 0.16 )
            draw.WordBox( 4, -TextWidth*0.5 - 5, -200, txt, "DermaLarge", Color( 0, 0, 0, 255 ), Color( 255, 255, 255, 255 ) )
        cam.End3D2D()
    end

end

if SERVER then
    function ENT:Initialize()
    
        self:SetModel( "models/items/ammocrate_smg1.mdl" )
        self:PhysicsInit( SOLID_VPHYSICS )
        self:SetMoveType( MOVETYPE_VPHYSICS )
        self:SetSolid( SOLID_VPHYSICS )
    
        local phys = self:GetPhysicsObject()
        if (phys:IsValid()) then phys:Wake() end

        self:SetUseType( CONTINUOUS_USE )
        self:SetDrawKeyPrompt( true )
        self:SetDrawProgress( true )

        self:SetNWInt( "WeaponsLeft", math.ceil( player.GetCount() / 4 ) )

        self.UnboxSound = CreateSound( self, "ui/item_open_crate_short.wav" )

    end
    
    function ENT:OnUseStart( ply )
        if self:GetNWInt( "WeaponsLeft", 0 ) == 0 then
            self:CancelUse( true )
        else
            self.UnboxSound:Play()
        end
    end

    function ENT:OnUseFinish( ply )
        self:ResetSequence( 1 )
        self.UnboxSound:Stop()
        self:EmitSound( "items/ammocrate_open.wav" )

        timer.Simple( 0.5, function()
            local weps = ents.TTT.GetSpawnableSWEPs()
            if weps then
                local w = weps[ math.random( #weps ) ]
                local ent = ents.Create( WEPS.GetClass( w ) )
                if IsValid( ent ) then
                    local pos = self:GetPos() + self:GetUp() * 20
                    ent:SetPos( pos )
                    ent:SetAngles( Angle( self:GetAngles().x, math.random( 0, 360 ), self:GetAngles().z ) )
                    ent:Spawn()
                    ent:PhysWake()
                    ent:GetPhysicsObject():SetVelocity( self:GetUp() * 250 + self:GetRight() * math.Rand( -50, 50 ) + self:GetForward() * math.Rand( 0, 100 ) )
                    ent:SetLocalAngularVelocity( VectorRand():Angle() * 500 ) -- this just doesn't work for some reason

                    if ent.AmmoEnt then
                        for i=1, math.random( 0, 2 ) do
                            local ammo = ents.Create( ent.AmmoEnt )
                            if IsValid( ammo ) then
                                pos.z = pos.z + 20
                                ammo:SetPos( pos )
                                ammo:SetAngles( VectorRand():Angle() )
                                ammo:Spawn()
                                ammo:PhysWake()
                                ammo:GetPhysicsObject():SetVelocity( self:GetUp() * 250 + self:GetRight() * math.Rand( -50, 50 ) + self:GetForward() * math.Rand( 0, 100 ) )

                            end
                        end
                    end

                    self:SetNWInt( "WeaponsLeft", self:GetNWInt( "WeaponsLeft" ) - 1 )
                    if self:GetNWInt( "WeaponsLeft" ) == 0 then
                        self:SetDrawKeyPrompt( false )
                    end

                end
            end
        end )

        timer.Simple( 2, function()
            self:ResetSequence( 2 )
            self:EmitSound( "items/ammocrate_close.wav" )
        end )
    end

    function ENT:OnUseCancel()
        self.UnboxSound:Stop()
    end

end